module Main where

import System.Environment (lookupEnv)
import Control.Monad
import Text.Printf
import Data.Time.Clock
import Database.PostgreSQL.Simple

times :: Int
times = 3000

selectTest :: Connection -> IO ()
selectTest conn = do
  replicateM_ times (query_ conn "SELECT id, bar FROM foo" :: IO [(Int, Int)])

updateTest :: Connection -> IO ()
updateTest conn =
    replicateM_ times $ execute_ conn "UPDATE foo SET bar=bar+1 WHERE id=1"

timeit :: IO a -> IO a
timeit action = do
  start <- getCurrentTime
  r <- action
  end <- getCurrentTime
  printf "seconds: %f\n" (realToFrac $ diffUTCTime end start :: Double)
  return r

main :: IO ()
main = do
  passwordMaybe <- lookupEnv "PG_T1_PASSWORD"
  case passwordMaybe of
    Nothing -> printf "Error: Please define PG_T1_PASSWORD environment variable"
    Just password -> do
      conn <- connectPostgreSQL "host=localhost dbname=t1 user=t1 password=62IWgtWiPCZdt8qu"
      timeit $ selectTest conn
      timeit $ updateTest conn
      close conn
