;; (quicklisp:quickload "postmodern")

(defpackage :db-bench
  (:use :common-lisp :postmodern))

(in-package :db-bench)

(defconstant +TIMES+ 3000)

;; (query "SELECT id, bar FROM foo")
;; (query (:select 'id 'bar :from 'foo))

;; (execute "UPDATE foo SET bar=bar+1 WHERE id=1")
;; (execute (:update 'foo :set 'bar (:+ 'bar 1) :where (:= 'id 1)))

(defmacro timeit (stmt times)
  (let ((start-sec (gensym))
	(start-msec (gensym)))
    `(multiple-value-bind (,start-sec ,start-msec) (sb-ext:get-time-of-day)
       (dotimes (_ ,times)
	 ,stmt)
       (format t "~,2f~%" (multiple-value-bind (end-sec end-msec) (sb-ext:get-time-of-day)
			    (/ (- (+ (* end-sec 1000000) end-msec)
				  (+ (* ,start-sec 1000000) ,start-msec))
			       1000000))))))

(defun select-test ()
  (timeit (query (:select 'id 'bar :from 'foo)) +TIMES+))
(defun update-test ()
  (timeit (execute (:update 'foo :set 'bar (:+ 'bar 1) :where (:= 'id 1))) +TIMES+))

(defun main ()
  (connect-toplevel "t1" "t1" "fNfwREMqO69TB9YqE+/OzF5/k+s=" "localhost")
  (select-test)
  (update-test)
  (disconnect-toplevel))
